
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Trial_sitesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const trial_sites = await db.trial_sites.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        greenhouse_block: data.greenhouse_block
        ||
        null
            ,
            
        location_notes: data.location_notes
        ||
        null
            ,
            
        rows_count: data.rows_count
        ||
        null
            ,
            
        columns_count: data.columns_count
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await trial_sites.setTrial( data.trial || null, {
            transaction,
        });
        
        await trial_sites.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return trial_sites;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const trial_sitesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                greenhouse_block: item.greenhouse_block
            ||
            null
            ,
            
                location_notes: item.location_notes
            ||
            null
            ,
            
                rows_count: item.rows_count
            ||
            null
            ,
            
                columns_count: item.columns_count
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const trial_sites = await db.trial_sites.bulkCreate(trial_sitesData, { transaction });

        // For each item created, replace relation files
        

        return trial_sites;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const trial_sites = await db.trial_sites.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.greenhouse_block !== undefined) updatePayload.greenhouse_block = data.greenhouse_block;
        
        
        if (data.location_notes !== undefined) updatePayload.location_notes = data.location_notes;
        
        
        if (data.rows_count !== undefined) updatePayload.rows_count = data.rows_count;
        
        
        if (data.columns_count !== undefined) updatePayload.columns_count = data.columns_count;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await trial_sites.update(updatePayload, {transaction});

        
        
        if (data.trial !== undefined) {
            await trial_sites.setTrial(
              
              data.trial,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await trial_sites.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return trial_sites;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const trial_sites = await db.trial_sites.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of trial_sites) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of trial_sites) {
                await record.destroy({transaction});
            }
        });


        return trial_sites;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const trial_sites = await db.trial_sites.findByPk(id, options);

        await trial_sites.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await trial_sites.destroy({
            transaction
        });

        return trial_sites;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const trial_sites = await db.trial_sites.findOne(
            { where },
            { transaction },
        );

        if (!trial_sites) {
            return trial_sites;
        }

        const output = trial_sites.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.plots_trial_site = await trial_sites.getPlots_trial_site({
            transaction
        });
        
        
        
        output.observation_events_trial_site = await trial_sites.getObservation_events_trial_site({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.trial = await trial_sites.getTrial({
            transaction
        });
        
        
        output.organizations = await trial_sites.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.trials,
        as: 'trial',
        
        where: filter.trial ? {
          [Op.or]: [
            { id: { [Op.in]: filter.trial.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.trial.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'trial_sites',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.greenhouse_block) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'trial_sites',
                        'greenhouse_block',
                        filter.greenhouse_block,
                    ),
                };
            }
            
            if (filter.location_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'trial_sites',
                        'location_notes',
                        filter.location_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.rows_countRange) {
                const [start, end] = filter.rows_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rows_count: {
                    ...where.rows_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rows_count: {
                    ...where.rows_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.columns_countRange) {
                const [start, end] = filter.columns_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    columns_count: {
                    ...where.columns_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    columns_count: {
                    ...where.columns_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.trial_sites.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'trial_sites',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.trial_sites.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

